## BODY
#[1]
#[3]
#[4]
#[2]

# Health System
effect give @s[tag=1] resistance 1 0 true
effect give @s[tag=!1] resistance 1 255 true

execute run bossbar set minecraft:colossal_health players @a[distance=..100]
execute as @s[tag=1] if score apply_damage colossal_vars matches 1 run function snc:shifters/mobs/colossal/apply_damage
execute as @s[tag=1] store result score health colossal_vars run data get entity @s Health
execute as @s[tag=1] run scoreboard players operation health colossal_vars -= #100 counter
execute store result bossbar colossal_health value run scoreboard players get health colossal_vars

execute if score terrain colossal_vars matches 9.. if entity @s[tag=1] run effect give @s instant_damage 1 3 

execute if entity @s[tag=2] if predicate snc:is_hurt run scoreboard players set apply_damage colossal_vars 1
execute if entity @s[tag=3] if predicate snc:is_hurt run scoreboard players set apply_damage colossal_vars 1
execute if entity @s[tag=4] if predicate snc:is_hurt run scoreboard players set apply_damage colossal_vars 1

execute as @s[tag=1] if entity @a[tag=colossal,limit=1,tag=transform,predicate=snc:is_hurt] run effect give @s instant_damage 1 4

# Kill when life goes to 0
execute as @s[tag=1] if score health colossal_vars matches ..0 run execute as @a[tag=colossal,limit=1,tag=transform] run function snc:shifters/mobs/colossal/remove_transform_when_hurt
# Kill cuando se acabe el tiempo
execute if score minutes colossal_vars matches ..0 if score seconds colossal_vars matches ..0 run execute as @a[tag=colossal,limit=1,tag=transform] run function snc:shifters/mobs/colossal/remove_transform


# mover el modelo
execute as @s at @a[tag=colossal,tag=transform,limit=1] run execute rotated ~ 0 run function snc:shifters/mobs/colossal/select_tp

# Rotar el modelo
execute store result score rotation colossal_vars run data get entity @s Rotation[0]
scoreboard players operation rotation colossal_vars -= player_rotation colossal_vars

execute unless score rotation colossal_vars matches -20..20 run data modify entity @s Rotation[0] set from entity @a[tag=colossal,tag=transform,limit=1] Rotation[0]

# Smoke
execute unless score @s[tag=1] smoke matches 0 run scoreboard players remove @s smoke 1

execute if score @s[tag=1] smoke matches 1 rotated ~ 0 run particle campfire_signal_smoke ^6 ^ ^ ^ ^1000000 ^ 0.00000007 0 force
execute if score @s[tag=1] smoke matches 1 rotated ~ 0 run particle campfire_signal_smoke ^-8 ^ ^ ^ ^1000000 ^ 0.00000007 0 force
execute as @s[tag=1] rotated ~ 0 run particle campfire_signal_smoke ^-1 ^8 ^-3 0 3 0 0.01 10 force

execute if score @s[tag=1] smoke matches ..0 run scoreboard players set @s smoke 3

# ANIMATE
execute as @s[tag=1] if score walk colossal_vars matches 0 run scoreboard players set walk colossal_vars 121
execute as @s[tag=1] if score idle colossal_vars matches 0 run scoreboard players set idle colossal_vars 90

#transformar
execute if entity @a[tag=colossal,limit=1,tag=born] as @s[tag=!3,tag=!4] run function snc:shifters/mobs/colossal/animate/born/select_born
#destransformar
execute as @s[tag=2] if entity @a[tag=colossal,limit=1,tag=!transform,tag=!born] run tag @s add dead
execute as @s[tag=1] if entity @a[tag=colossal,limit=1,tag=!transform,tag=!born] run tag @s add dead

execute as @s[tag=!3,tag=!4] if entity @a[tag=colossal,limit=1,tag=!atk,tag=!walk,tag=transform,tag=!born] run function snc:shifters/mobs/colossal/animate/idle/select_idle

#execute if entity @a[tag=cart,limit=1,tag=c1,tag=!born,tag=transform] run function snc:shifters/mobs/cart/animate/attack_1

execute as @s[tag=!3,tag=!4] if entity @a[tag=colossal,limit=1,tag=co4,tag=!born,tag=transform] run function snc:shifters/mobs/colossal/animate/atk_4

execute as @s[tag=!3,tag=!4] if entity @a[tag=colossal,limit=1,tag=co3,tag=!born,tag=transform] run function snc:shifters/mobs/colossal/animate/atk_3/select_atk

execute as @s[tag=!3,tag=!4] if entity @a[tag=colossal,limit=1,tag=co2,tag=!born,tag=transform] run function snc:shifters/mobs/colossal/animate/atk_2/select_atk_2

execute as @s[tag=!3,tag=!4] if entity @a[tag=colossal,limit=1,tag=!atk,tag=walk,tag=transform,tag=!born] run function snc:shifters/mobs/colossal/animate/walk/select_walk

execute as @s[tag=1] if score idle colossal_vars matches 1..90 run scoreboard players remove idle colossal_vars 1
execute as @s[tag=1] if score action colossal_vars matches 1.. run scoreboard players remove action colossal_vars 1
execute as @s[tag=1] if score walk colossal_vars matches 1..121 run scoreboard players remove walk colossal_vars 1