# First time joining world
execute as @s[tag=!init] run function snc:controller/manual/init

# ODM Effects
execute as @s[predicate=snc:has_gas_trigger,predicate=snc:has_odm] run function snc:player/odm/effects
execute as @s[nbt={Inventory:[{Slot:103b,id:"minecraft:carved_pumpkin",tag:{survey_cops:1b}}]}] run effect give @s night_vision 20 0 true

# Spread Titans
execute if entity @s[tag=near] unless entity @e[tag=titan,distance=..96,limit=1,sort=nearest] run tag @s remove near
#Spread the spawners if there's no titan nearby
execute if entity @s[tag=!near] run spreadplayers ~ ~ 15 50 false @e[type=pig, tag=!not_titan,sort=furthest,limit=5]

# Pure Titan
execute as @s[tag=shifter] run function snc:player/shifter
execute if entity @s[tag=wrap] unless entity @e[tag=titan,distance=0..5,limit=1,sort=nearest] run tag @s remove wrap


# Give and remove gun cart_titan
execute unless predicate snc:is_riding_turret run tag @s remove gun

# give cool
scoreboard players set @s[tag=!throw] man_cool 0

execute as @s[nbt={SelectedItem:{id:"minecraft:written_book",tag:{manual:1b}}}] run scoreboard players enable @s manual
execute as @s[scores={manual=1..}] run function snc:controller/manual/trigger
execute as @s[scores={manual=..-1}] run function snc:controller/manual/config

# set time
execute store result score hora clock run time query daytime

execute if score hora clock matches 5..25 run tellraw @s {"text":" Sunrise ------------ ☼ ------------","bold":true,"color":"gold","hoverEvent":{"action":"show_text","contents":[{"text":"The titans are rising","color":"gold"}]}}

execute if score hora clock matches 6005..6025 run tellraw @s {"text":" Noon ------------ ☼ ------------","bold":true,"color":"dark_red","hoverEvent":{"action":"show_text","contents":[{"text":"The titans are way more active","color":"dark_red"}]}}

execute if score hora clock matches 12005..12025 run tellraw @s {"text":" Sunset ------------ ☼ ------------","bold":true,"color":"gold","hoverEvent":{"action":"show_text","contents":[{"text":"The titans are getting slower","color":"gold"}]}}

execute if score hora clock matches 14505..14525 run tellraw @s {"text":" Night ------------ ☼ ------------","bold":true,"color":"aqua","hoverEvent":{"action":"show_text","contents":[{"text":"The titans are vulnerable","color":"aqua"}]}}