# Health System
execute at @s run bossbar set minecraft:cart_health players @a[distance=..50]
execute store result score health cart_vars run data get entity @s Health
scoreboard players operation health cart_vars -= #100 counter
execute store result bossbar cart_health value run scoreboard players get health cart_vars

execute if entity @a[tag=cart,limit=1,tag=transform,predicate=snc:is_hurt] run effect give @s instant_damage 1 3 

# Kill cuando baje la vida
execute if score health cart_vars matches ..0 run execute as @a[tag=cart,limit=1,tag=transform] run function snc:shifters/mobs/cart/remove_transform_when_hurt

# Kill cuando se acabe el tiempo
execute if score minutes cart_vars matches ..0 if score seconds cart_vars matches ..0 run execute as @a[tag=cart,limit=1,tag=transform] run function snc:shifters/mobs/cart/remove_transform

# mover el modelo
execute as @s at @a[tag=cart,tag=transform,limit=1] run execute rotated ~ 0 run function snc:shifters/mobs/cart/select_tp

# Rotar el modelo
execute store result score rotation cart_vars run data get entity @s Rotation[0]
scoreboard players operation rotation cart_vars -= player_rotation cart_vars

execute unless score rotation cart_vars matches -20..20 run data modify entity @s Rotation[0] set from entity @a[tag=cart,tag=transform,limit=1] Rotation[0]
# animate 

execute if score walk cart_vars matches 0 run scoreboard players set walk cart_vars 20
execute if score idle cart_vars matches 0 run scoreboard players set idle cart_vars 40

#Aqui no se puede usar desde n sino desde n-1 porque se opera antes
#transformar
execute if entity @a[tag=cart,limit=1,tag=born] run function snc:shifters/mobs/cart/animate/born
#destransformar
execute if entity @a[tag=cart,limit=1,tag=!transform,tag=!born] run tag @s add dead

execute if entity @a[tag=cart,limit=1,tag=!atk,tag=!c2,tag=!walk,tag=transform,tag=!born] run function snc:shifters/mobs/cart/animate/idle

execute if entity @a[tag=cart,limit=1,tag=c1,tag=!born,tag=transform] run function snc:shifters/mobs/cart/animate/attack_1

execute if entity @a[tag=cart,limit=1,tag=c2,tag=!atk,tag=!born,tag=transform] run function snc:shifters/mobs/cart/animate/attack_2

execute if entity @a[tag=cart,limit=1,tag=c3,tag=!born,tag=transform] run function snc:shifters/mobs/cart/animate/attack_3

execute if entity @a[tag=cart,limit=1,tag=!atk,tag=!c2,tag=walk,tag=transform,tag=!born] run function snc:shifters/mobs/cart/animate/walk

#Cambiar cabeza
execute if predicate snc:has_effect_resistance run function snc:shifters/mobs/cart/animate/head_armor

#Cambiar cabeza
execute unless predicate snc:has_effect_resistance run function snc:shifters/mobs/cart/animate/head_bare

execute if score idle cart_vars matches 1..40 run scoreboard players remove idle cart_vars 1
execute if score action cart_vars matches 1.. run scoreboard players remove action cart_vars 1
execute if score walk cart_vars matches 1..20 run scoreboard players remove walk cart_vars 1