execute as @s if entity @s[tag=!first] run function snc:shifters/mobs/cart/born
# Its moving!
execute if score @s player_walking matches 1.. run tag @s add walk
execute if predicate snc:is_sprinting run tag @s add walk
execute if score @s player_walking matches 0 unless predicate snc:is_sprinting run tag @s remove walk
scoreboard players set @s player_walking 0

# Jump
execute if score @s player_jumping matches 1.. if score is_on_floor cart_vars matches 1 run function snc:shifters/mobs/cart/attack/jump

# Rotation
execute store result score player_rotation cart_vars run data get entity @s Rotation[0]

# Remove crouch if walking or jumping
execute as @s[tag=c3] run function snc:shifters/mobs/cart/attack_4/select_state

# Sube una pendiente
function snc:shifters/mobs/cart/height

effect give @s slow_falling 3 0 true
effect give @s invisibility 2 0 true
effect give @s resistance 3 255 true
effect give @s saturation 1 0 true

# If not jumping walks
execute unless score @s[tag=!born] player_jumping matches 1.. unless block ~ ~-5 ~ #snc:filter_shifter rotated ~ 0 run function snc:shifters/mobs/cart/attack/floor

# Si no esta en el suelo pone la variable cart_is_on_floor en 0
execute if block ~ ~-1 ~ air run scoreboard players set is_on_floor cart_vars 0

# Guardar el valor del Motion para saber cuando cae
execute store result score motion cart_vars run data get entity @s Motion[1] 10000

# Si cayendo ya no esta saltando
execute if score motion cart_vars matches ..0 run scoreboard players set @s player_jumping 0

# Si esta en el piso y salta
execute if score @s[tag=!atk] using_carrot matches 1.. run function snc:shifters/select_using_carrot

# Set state
function snc:shifters/mobs/cart/select_state

# Atking
execute as @s[tag=atk] if score action cart_vars matches ..0 run function snc:shifters/select_atk

# Kill cart
execute if predicate snc:is_riding_turret run scoreboard players set kill_pos_2 cart_vars 1